Index: admin_templates/tools/system_tools.tpl
===================================================================
--- admin_templates/tools/system_tools.tpl	(revision 13936)
+++ admin_templates/tools/system_tools.tpl	(working copy)
@@ -28,105 +28,273 @@
 	</tr>
 </inp2:m_DefineElement>
 
-<table width="100%" cellspacing="0" cellpadding="4" class="bordered">
-	<!--##<inp2:m_RenderElement name="subsection" title="la_section_General"/>##-->
-		<inp2:m_RenderElement name="service_elem" title="Reset mod_rewrite Cache" event_name="OnResetModRwCache"/>
-		<inp2:m_RenderElement name="service_elem" title="Reset SMS Menu Cache" event_prefix="c" event_name="OnResetCMSMenuCache"/>
-		<inp2:m_RenderElement name="service_elem" title="Reset Sections Cache" event_name="OnResetSections"/>
-		<inp2:m_RenderElement name="service_elem" title="Reset Configs Cache" event_name="OnResetConfigsCache"/>
-		<inp2:m_RenderElement name="service_elem" title="Re-build Multilanguage Fields" event_prefix="lang" event_name="OnReflectMultiLingualFields"/>
+<style type="text/css">
+	.summary-box {
+		border: 1px solid black;
+		margin-bottom: 4px;
+	}
 
-	<inp2:m_RenderElement name="subsection" title="la_section_Templates"/>
-		<inp2:m_RenderElement name="service_elem" title="Re-build Themes Files" event_name="OnRebuildThemes"/>
-		<tr class="<inp2:m_odd_even odd='table-color1' even='table-color2'/>">
-			<inp2:m_inc param="tab_index" by="1"/>
-			<td class="text" style="width: 300px;">
-				Re-compile Templates
-			</td>
-			<td valign="top" colspan="2">
-				<input class="button" type="button" onclick="compile_templates();" value="Run">
-			</td>
-		</tr>
-		<inp2:m_RenderElement name="service_elem" title="Clear Templates Cache" event_name="OnDeleteCompiledTemplates"/>
-	<inp2:m_RenderElement name="subsection" title="la_section_Configs"/>
-		<tr class="<inp2:m_odd_even odd='table-color1' even='table-color2'/>">
-			<inp2:m_inc param="tab_index" by="1"/>
-			<td class="text" style="width: 300px;">
-				Table Structure:
-			</td>
-			<td valign="top" colspan="2">
+	.summary-box .title {
+		color: white;
+		font-weight: bold;
+		padding: 6px 4px;
+		vertical-align: middle;
+		background-color: #4A92CE;
+		border-bottom: 1px solid black;
+	}
+
+	.summary-box .content {
+		padding: 4px;
+		background-color: #F6F6F6;
+	}
+
+	.summary-box .hint {
+		font-size: 10px;
+		color: grey;
+		margin-bottom: 3px;
+	}
+
+	.summary-box .group {
+		border-bottom: 1px solid black;
+		margin-bottom: 4px;
+		padding-bottom: 4px;
+	}
+
+	/*.summary-box .button {
+		font-size: 13px;
+		padding: 1px 3px;
+		border: 1px solid black;
+		color: white;
+		font-weight: bold;
+		background: #4A92CE;
+	}
+
+	.summary-box .button[disabled] {
+		color: #676767;
+		background-color: #F6F6F6;
+		border-color: grey;
+	}*/
+
+	.summary-box li {
+		padding-bottom: 4px;
+	}
+</style>
+
+<br />
+
+<div style="float: left; width: 49%;">
+	<div class="summary-box">
+		<div class="title">
+			<inp2:m_Phrase name="la_section_Configs"/>
+		</div>
+		<div class="content">
+			<div class="group">
+				Reset Parsed Data
+				<div class="hint">
+					Updates various cached data, obtained from discovered units (defined PHP classes, hooks,
+					agents, used configuration variables, replacement templates, rewrite listeners and
+					installed modules).<br/>
+					Cache Key: <strong>master:configs_parsed</strong>
+				</div>
+
+				<input type="button" class="button" onclick="submit_event('adm', 'OnResetParsedData');" value="Run"/> or
+				<input type="button" class="button" onclick="Application.SetVar('validate_configs', 1); submit_event('adm', 'OnResetParsedData'); Application.SetVar('validate_configs', null);" value="Run &amp; Validate"/>
+			</div>
+
+			<div class="group">
+				Reset Sections Cache
+				<div class="hint">
+					Updates cache of Administrative Console left menu section definitions obtained from discovered units.
+					When newly added sections doesn't appear - try this option.<br/>
+					Cache Key: <strong>master:sections_parsed</strong>
+				</div>
+
+				<input type="button" class="button" onclick="submit_event('adm', 'OnResetSections');" value="Run"/>
+			</div>
+
+			<div class="group">
+				Re-build Multilanguage Fields
+				<div class="hint">
+					Adds missing columns (in format "l&lt;N&gt;_FieldName") to store data of translatable fields. Such
+					action is performed automatically, only when new language is added. This option should be used only,
+					to synchronize columns of newly added translatable fields definitions in units.
+				</div>
+
+				<input type="button" class="button" onclick="submit_event('lang', 'OnReflectMultiLingualFields');" value="Run"/>
+			</div>
+
+			<div class="group">
+				Table Structure
+				<div class="hint">
+					Shows structure of the table with given name (table prefix is optional) or table,
+					associated with given "unit config prefix".
+				</div>
 				<input type="text" name="table_name" value="" size="30"/>
-				<input class="button" type="button" onclick="show_structure('adm', 'OnGenerateTableStructure');" value="Run">
-				<span class="small">table name (table prefix is optional) OR "unit config" prefix</span>
-			</td>
-		</tr>
+				<input type="button" class="button" onclick="show_structure('adm', 'OnGenerateTableStructure');" value="Run"/>
+			</div>
 
-		<tr class="<inp2:m_odd_even odd='table-color1' even='table-color2'/>">
-			<inp2:m_inc param="tab_index" by="1"/>
-			<td class="text" style="width: 300px;">
-				Locate Unit Config File:
-			</td>
-			<td valign="top" colspan="2">
+			<div class="group">
+				Locate Unit Config File
+				<div class="hint">
+					Shows location of unit config file, associated with given unit config prefix.
+				</div>
 				<input type="text" name="config_prefix" value="" size="30"/>
-				<input class="button" type="button" onclick="check_prefix_config();" value="Run">
-				<span class="small">unit config prefix</span>
-			</td>
-		</tr>
+				<input type="button" class="button" onclick="check_prefix_config();" value="Run"/>
+			</div>
+
+			<div>
+				Reset Configs Cache
+				<div class="hint">
+					<ul>
+						<li>
+							Discovers new units, by scanning "core" and "modules" folders (execution time is directly
+							proportional to discovered unit count).<br/>
+							Cache Key: <strong>master:config_files</strong>
+						</li>
+
+						<li>
+							Updates various cached data, obtained from discovered units (defined PHP classes, hooks,
+							agents, used configuration variables, replacement templates, rewrite listeners and
+							installed modules).<br/>
+							Cache Key: <strong>master:configs_parsed</strong>
+						</li>
+
+						<li>
+							Deletes compiled Administrative Console skins (css files).
+						</li>
+					</ul>
+				</div>
+				<input type="button" class="button" onclick="submit_event('adm', 'OnResetConfigsCache');" value="Run"/>
+			</div>
+		</div>
+	</div>
+
+	<div class="summary-box">
+		<div class="title">
+			<inp2:m_Phrase name="la_section_FrontEnd"/>
+		</div>
+		<div class="content">
+			<div class="group">
+				Reset mod_rewrite Cache
+				<div class="hint">
+					Deletes mapping between Front-End page urls and actual theme templates, that are displayed. This
+					mapping is updated automatically, when data in "Structure & Data" section is changed.
+					This option should be used only in case, when displayed page differs from page, that usually is
+					displayed, when given url is visited.
+				</div>
+
+				<input type="button" class="button" onclick="submit_event('adm', 'OnResetModRwCache');" value="Run"/>
+			</div>
+
+			<div>
+				Reset SMS Menu Cache
+				<div class="hint">
+					Deletes cached version of Front-End menu (displayed via "&lt;inp2:st_CachedMenu .../&gt;" tag). This
+					cache is updated automatically, when data in "Structure & Data" section is changed. This option
+					should be used only in case, when displayed menu on Front-End doesn't match expected menu, defined in
+					Administrative Console.<br/>
+					Cache Keys: <strong>master:cms_menu</strong>, <strong>master:StructureTree</strong>, <strong>master:template_mapping</strong>
+				</div>
+
+				<input type="button" class="button" onclick="submit_event('c', 'OnResetCMSMenuCache');" value="Run"/>
+			</div>
+		</div>
+	</div>
+</div>
+
+<div style="float: right; width: 49%;">
+	<div class="summary-box">
+		<div class="title">
+			<inp2:m_Phrase name="la_section_Templates"/>
+		</div>
+		<div class="content">
+			<div class="group">
+				Re-build Themes Files
+				<div class="hint">
+					Discovers newly added Front-End theme templates. This action is performed automatically only, when
+					new theme is added or existing theme is enabled. This option should be used to solve case, when
+					"404 Not Found" page is shown instead of expected newly added page/template.<br/>
+
+					This function is also available via "Refresh" toolbar button in "Themes" section. It also deletes
+					all compressed ".js"/".css" files, which are used by &lt;inp2:m_Compress .../&gt; tag.
+				</div>
+				<input type="button" class="button" onclick="submit_event('adm', 'OnRebuildThemes');" value="Run"/>
+			</div>
+
+			<div class="group">
+				Re-compile Templates
+				<div class="hint">
+					Complies all templates from themes, enabled on Front-End and enabled modules from administrative
+					console. This option also check &lt;inp2:.../&gt; tag syntax across all In-Portal installation.
+					Such action is never performed automatically.
+				</div>
+				<input type="button" class="button" onclick="compile_templates();" value="Run"/>
+			</div>
+
+			<div>
+				Clear Templates Cache
+				<div class="hint">
+					Deletes all compiled templates from Administrative Console and Front-End themes. Should be used in
+					maintenance purposes only, since it doesn't give any benefits except temporary disk space
+					preservation. In any case all templates will be re-compiled once, they are visited.
+				</div>
+				<input type="button" class="button" onclick="submit_event('adm', 'OnDeleteCompiledTemplates');" value="Run"/>
+			</div>
+		</div>
+	</div>
+
 	<inp2:m_if check="adm_MemoryCacheEnabled">
-		<inp2:m_RenderElement name="subsection" title="la_section_MemoryCache"/>
-			<inp2:m_RenderElement name="service_elem" title="Reset All Keys" event_name="OnResetMemcache"/>
+		<div class="summary-box">
+			<div class="title">
+				<inp2:m_Phrase name="la_section_MemoryCache"/>
+			</div>
+			<div class="content">
+				<div class="group">
+					Reset All Keys
+					<div class="hint">
+						Invalidates all data, that is stored in the cache. Not recommended for regular use due long execution time.
+					</div>
+					<input type="button" class="button" onclick="submit_event('adm', 'OnResetMemcache');" value="Run"/>
+				</div>
 
-			<tr class="<inp2:m_odd_even odd='table-color1' even='table-color2'/>">
-				<inp2:m_inc param="tab_index" by="1"/>
-				<td class="text" style="width: 300px;">
+				<div class="group">
 					Key Name:
-				</td>
-				<td valign="top" colspan="2">
-					<table cellpadding="0" cellspacing="0">
-						<tr>
-							<td colspan="2">
-								<a href="#" class="quick-memory-cache-key">master:configs_parsed</a>,
-								<a href="#" class="quick-memory-cache-key">master:config_files</a>,
-								<a href="#" class="quick-memory-cache-key">master:sections_parsed</a>,
-								<a href="#" class="quick-memory-cache-key">master:cms_menu</a>,
-								<a href="#" class="quick-memory-cache-key">master:template_mapping</a>,
-								<a href="#" class="quick-memory-cache-key">master:StructureTree</a>
-								<br/>
-								<br/>
-							</td>
-						</tr>
-						<tr>
-							<td style="width: 440px;">
-								<input type="text" id="memory_cache_key_name" value="" style="width: 440px;"/>
-							</td>
-							<td style="padding-bottom: 2px; padding-left: 4px;">
-								<input type="button" class="button" id="memory_cache_get" value="Get Value"/>
-							</td>
-						</tr>
-					</table>
-				</td>
-			</tr>
-			<tr class="<inp2:m_odd_even odd='table-color1' even='table-color2'/>">
-				<inp2:m_inc param="tab_index" by="1"/>
-				<td class="text" style="width: 300px;">
+					<div class="hint">
+						Key name, used to retrieve/store data in the cache (used in "kApplication::setCache" and "kApplication::getCache" methods).
+					</div>
+
+					<input type="text" id="memory_cache_key_name" style="width: 230px;" value=""/>
+					<input type="button" class="button" id="memory_cache_get" value="Retrieve Value"/>
+
+					<div style="margin-top: 3px;">
+						Popular keys:<br/>
+						<a href="#" class="quick-memory-cache-key">master:configs_parsed</a>,
+						<a href="#" class="quick-memory-cache-key">master:config_files</a>,
+						<a href="#" class="quick-memory-cache-key">master:sections_parsed</a>,
+						<a href="#" class="quick-memory-cache-key">master:cms_menu</a>,
+						<a href="#" class="quick-memory-cache-key">master:template_mapping</a>,
+						<a href="#" class="quick-memory-cache-key">master:StructureTree</a>
+					</div>
+				</div>
+
+				<div>
 					Key Value:
-				</td>
-				<td valign="top" colspan="2">
-					<table cellpadding="0" cellspacing="0">
-						<tr>
-							<td valign="bottom">
-								<textarea id="memory_cache_key_value" style="width: 440px; height: 120px;"></textarea>
-							</td>
-							<td valign="bottom" style="padding-bottom: 2px; padding-left: 4px;">
-								<input type="button" class="button" id="memory_cache_set" value="Set Value"/>
-							</td>
-						</tr>
-					</table>
-				</td>
-			</tr>
+					<div class="hint">
+						Retrieved value (for getting) or new value (for setting) of key name, entered/selected above.
+					</div>
+					<div style="margin-right: 4px; margin-bottom: 3px;">
+						<textarea id="memory_cache_key_value" style="width: 100%; height: 200px;"></textarea><br/>
+					</div>
+
+					<input type="button" class="button" id="memory_cache_set" value="Store Value"/>
+				</div>
+			</div>
+		</div>
 	</inp2:m_if>
-</table>
+</div>
 
+<div style="clear: both;"></div>
+
 <script type="text/javascript">
 	<inp2:m_if check="m_Get" name="refresh_tree">
 		getFrame('menu').location.reload();
Index: install/install_toolkit.php
===================================================================
--- install/install_toolkit.php	(revision 13936)
+++ install/install_toolkit.php	(working copy)
@@ -816,6 +816,7 @@
 		function deleteCache($refresh_permissions = false)
 		{
 			$this->Application->HandleEvent($event, 'adm:OnResetConfigsCache');
+			$this->Application->HandleEvent($event, 'adm:OnResetSections');
 			$this->Application->HandleEvent($event, 'c:OnResetCMSMenuCache');
 
 			$this->Conn->Query('DELETE FROM ' . TABLE_PREFIX . 'CachedUrls');
Index: kernel/utility/debugger.php
===================================================================
--- kernel/utility/debugger.php	(revision 13936)
+++ kernel/utility/debugger.php	(working copy)
@@ -228,8 +228,13 @@
 					$dbg_constMap['DBG_SKIP_REPORTING'] = 1;
 				}
 
+				// allows to validate unit configs via request variable
+				if ( !array_key_exists('DBG_VALIDATE_CONFIGS', $dbg_constMap) ) {
+					$dbg_constMap['DBG_VALIDATE_CONFIGS'] = array_key_exists('validate_configs', $_GET) ? (int)$_GET['validate_configs'] : 0;
+				}
+
 				// when validation configs, don't show sqls for better validation error displaying
-				if (array_key_exists('DBG_VALIDATE_CONFIGS', $dbg_constMap) && $dbg_constMap['DBG_VALIDATE_CONFIGS']) {
+				if ($dbg_constMap['DBG_VALIDATE_CONFIGS']) {
 					$dbg_constMap['DBG_SQL_PROFILE'] = 0;
 				}
 
Index: units/admin/admin_events_handler.php
===================================================================
--- units/admin/admin_events_handler.php	(revision 13936)
+++ units/admin/admin_events_handler.php	(working copy)
@@ -43,7 +43,7 @@
 		$perm_value = null;
 
 		$system_events = Array (
-			'OnResetModRwCache', 'OnResetSections', 'OnResetConfigsCache', 'OnResetMemcache',
+			'OnResetModRwCache', 'OnResetSections', 'OnResetConfigsCache', 'OnResetParsedData', 'OnResetMemcache',
 			'OnDeleteCompiledTemplates', 'OnCompileTemplates', 'OnGenerateTableStructure',
 			'OnRebuildThemes', 'OnCheckPrefixConfig', 'OnMemoryCacheGet', 'OnMemoryCacheSet'
 		);
@@ -122,21 +122,35 @@
 
 		if ($this->Application->isCachingType(CACHING_TYPE_MEMORY)) {
 			$this->Application->deleteCache('master:config_files');
-			$this->Application->deleteCache('master:configs_parsed');
-			$this->Application->deleteCache('master:sections_parsed');
 		}
 		else {
 			$this->Application->deleteDBCache('config_files');
-			$this->Application->deleteDBCache('configs_parsed');
-			$this->Application->deleteDBCache('sections_parsed');
 		}
 
+		$this->OnResetParsedData($event);
+
 		$skin_helper =& $this->Application->recallObject('SkinHelper');
 		/* @var $skin_helper SkinHelper */
 
 		$skin_helper->deleteCompiled();
+	}
 
-		$event->SetRedirectParam('refresh_tree', 1);
+	/**
+	 * Resets parsed data from unit configs
+	 *
+	 * @param kEvent $event
+	 */
+	function OnResetParsedData(&$event)
+	{
+		if ($this->Application->GetVar('ajax') == 'yes') {
+			$event->status = erSTOP;
+		}
+
+		$this->Application->UnitConfigReader->ResetParsedData();
+
+		if ( $this->Application->GetVar('validate_configs') ) {
+			$event->SetRedirectParam('validate_configs', 1);
+		}
 	}
 
 	function OnResetMemcache(&$event)
